	SUBROUTINE CTRLINF
************************************************************
*  <CTRLINF> checks control strings                        *
************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTINP    ,ONLY: INPINFO,RUNMODE               !!! from init
	USE COM_EXTENS                                         !!! from setup
	USE COM_UNIT      ,ONLY: IUT                           !!! from setup
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER UN(100)*2,RUN*130,RUM*130,INF*130,INM*130
      LOGICAL PRESENT
C RECOGNIZE INPINFO
      CALL CONVLOW(INPINFO,130)
      CALL RMBLANK(INPINFO,130)
	DO IPOS=1,130
	INF(IPOS:IPOS)=' '
	INM(IPOS:IPOS)=' '
	ENDDO
	IF(INPINFO(1:8).EQ.'standard')INF(1:3*LENEXTN+2)=
     &EXTNINI(1:LENEXTN)//'+'//EXTNSTR(1:LENEXTN)//'+'//
     &EXTNSCS(1:LENEXTN)
	IF(INPINFO(1:8).EQ.'hoppings')INF(1:4*LENEXTN+3)=
     &EXTNINI(1:LENEXTN)//'+'//EXTNSTR(1:LENEXTN)//'+'//
     &EXTNSCS(1:LENEXTN)//'+'//EXTNHOP(1:LENEXTN)
	IF(INPINFO(1:8).EQ.'hubbards')INF(1:4*LENEXTN+3)=
     &EXTNINI(1:LENEXTN)//'+'//EXTNSTR(1:LENEXTN)//'+'//
     &EXTNSCS(1:LENEXTN)//'+'//EXTNHUB(1:LENEXTN)
      IF(INF(1:1).EQ.' ')INF=INPINFO
      IF(INF(1:1).EQ.' ')INF='Error: Blank INPINFO String!'
	INM=INF !!! Save translated string
C CHECK REGISTRED DATA TYPES
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNINI,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNSTR,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNSCS,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNHOP,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNHUB,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNPNT,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNENR,LENEXTN)
C CHECK ERRORS
	IERR=0
	DO IPOS=1,130
	IF(INF(IPOS:IPOS).NE.'+'.AND.INF(IPOS:IPOS).NE.' ')IERR=1
	ENDDO
	IF(IERR.EQ.1)THEN
	WRITE(IUT,*)'Terminated in <CTRLINF>:'
	WRITE(IUT,*)'INPINFO string contains errors.'
	WRITE(IUT,*)'INPINFO string read      :',INPINFO
	WRITE(IUT,*)'INPINFO string translated:',INF
	WRITE(IUT,*)'Valid keywords in RUNMODE string are:'
	WRITE(IUT,*)'--------------------------------'
	WRITE(IUT,*)'   KEYWORD1      or KEYWORD2    '
      WRITE(IUT,*)'   Standard       | '
     &//EXTNINI(1:LENEXTN)//'+'//EXTNSTR(1:LENEXTN)//'+'//
     &EXTNSCS(1:LENEXTN)
      WRITE(IUT,*)'   Hoppings       | '
     &//EXTNINI(1:LENEXTN)//'+'//EXTNSTR(1:LENEXTN)//'+'//
     &EXTNSCS(1:LENEXTN)//'+'//EXTNHOP(1:LENEXTN)
      WRITE(IUT,*)'   Hubbards       | '
     &//EXTNINI(1:LENEXTN)//'+'//EXTNSTR(1:LENEXTN)//'+'//
     &EXTNSCS(1:LENEXTN)//'+'//EXTNHUB(1:LENEXTN)
	WRITE(IUT,*)'Different combinations of KEYWORD2 types'
	WRITE(IUT,*)'are allowed, e.g. INPINFO='//
     &EXTNINI(1:LENEXTN)//'+'//EXTNSTR(1:LENEXTN)//'+'//
     &EXTNSCS(1:LENEXTN)//'+'//EXTNHUB(1:LENEXTN)//'+'//
     &EXTNHOP(1:LENEXTN)//'.'
	CALL FULLSTOP(' ')
	ENDIF
C RESET INPINFO STRING NOW
	INPINFO=INM
C ***************************************************************
C RECOGNIZE RUNNING MODE
      CALL RMBLANK(RUNMODE,130)
      CALL CONVLOW(RUNMODE,130)
	DO IPOS=1,130
	RUN(IPOS:IPOS)=' '
	RUM(IPOS:IPOS)=' '
	ENDDO
	IF(RUNMODE(1:13).EQ.'prepareforscf'   )
     &RUN(1:LENEXTN) =EXTNCON(1:LENEXTN)
	IF(RUNMODE(1:16).EQ.'self-consistency')
     &RUN(1:3*LENEXTN+2)=EXTNCON(1:LENEXTN)//'+'//
     &EXTNSCF(1:LENEXTN)//'+'//EXTNOUT(1:LENEXTN)
	IF(RUNMODE(1:8 ).EQ.'fatbands'        )
     &RUN(1:LENEXTN) =EXTNFAT(1:LENEXTN)
	IF(RUNMODE(1:15).EQ.'densityofstates' )
     &RUN(1:LENEXTN) =EXTNDOS(1:LENEXTN)
	IF(RUNMODE(1:11).EQ.'energybands'     )
     &RUN(1:LENEXTN) =EXTNBND(1:LENEXTN)
	IF(RUNMODE(1:12).EQ.'fermisurface'    )
     &RUN(1:LENEXTN) =EXTNFRS(1:LENEXTN)
	IF(RUNMODE(1:13).EQ.'wavefunctions'   )
     &RUN(1:LENEXTN) =EXTNPSI(1:LENEXTN)
	IF(RUNMODE(1:13).EQ.'fullpotential'   )
     &RUN(1:LENEXTN) =EXTNPOT(1:LENEXTN)
      IF(RUN(1:1).EQ.' ')RUN=RUNMODE
      IF(RUN(1:1).EQ.' ')RUN='Error: Blank RUNMODE String!'
	RUM=RUN !!! Save translated string
C CHECK REGISTRED DATA TYPES
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNCON,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNFTR,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNATM,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNGRP,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNOPT,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNODF,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNCHI,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNPSI,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNTMP,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNBND,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNFRS,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNPOT,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNFAT,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNDOS,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNGRF,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNSCF,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNHUB,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNHBR,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNHPP,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNHOP,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNOUT,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNPNT,LENEXTN)
C CHECK ERRORS
	IERR=0
	DO IPOS=1,130
	IF(RUN(IPOS:IPOS).NE.'+'.AND.RUN(IPOS:IPOS).NE.' ')IERR=1
	ENDDO
	IF(IERR.EQ.1)THEN
	WRITE(IUT,*)'Terminated in <READINI>:'
	WRITE(IUT,*)'RUNMODE string contains errors.'
	WRITE(IUT,*)'RUNMODE string read      :',RUNMODE
	WRITE(IUT,*)'RUNMODE string translated:',RUN
	WRITE(IUT,*)'Valid keywords in RUNMODE string are:'
	WRITE(IUT,*)'--------------------------------'
	WRITE(IUT,*)'   KEYWORD1      or KEYWORD2    '
      WRITE(IUT,*)'Prepare for SCF   | '//EXTNCON(1:LENEXTN)
      WRITE(IUT,*)'Self-consistency  | '//EXTNCON(1:LENEXTN)//'+'//
     &EXTNSCF(1:LENEXTN)//'+'//EXTNOUT(1:LENEXTN)
      WRITE(IUT,*)'Fat bands         | '//EXTNFAT(1:LENEXTN)
      WRITE(IUT,*)'Density of states | '//EXTNDOS(1:LENEXTN)
      WRITE(IUT,*)'Energy bands      | '//EXTNBND(1:LENEXTN)
      WRITE(IUT,*)'Fermi surface     | '//EXTNFRS(1:LENEXTN)
      WRITE(IUT,*)'Wave functions    | '//EXTNPSI(1:LENEXTN)
      WRITE(IUT,*)'Full potential    | '//EXTNPOT(1:LENEXTN)
      WRITE(IUT,*)'Custom            |  +++        '
	WRITE(IUT,*)'--------------------------------'
	WRITE(IUT,*)'Different combinations of KEYWORD2 types'
	WRITE(IUT,*)'are allowed, e.g. RUNMODE='//
     &EXTNCON(1:LENEXTN)//'+'//EXTNDOS(1:LENEXTN)//'+'//
     &EXTNPSI(1:LENEXTN)//'+'//EXTNPOT(1:LENEXTN)//'+'//
     &EXTNOUT(1:LENEXTN)//'.'
	WRITE(IUT,*)'Note only that KEYWORD2='//EXTNFAT(1:LENEXTN)//
     & ' cannot be combined'
	WRITE(IUT,*)'with KEYWORD2='//EXTNDOS(1:LENEXTN)//','//
     &EXTNBND(1:LENEXTN)//','//EXTNPSI(1:LENEXTN)//','//
     &EXTNPOT(1:LENEXTN)//','//EXTNPOT(1:LENEXTN)//','//
     &EXTNSCF(1:LENEXTN)//' , since,'
	WRITE(IUT,*)'this will require spontaneous handling of'
	WRITE(IUT,*)'k-point samplings along high-symmetry'
	WRITE(IUT,*)'lines and within the tetrahedra, which is not'
	WRITE(IUT,*)'avaiable.'
	CALL FULLSTOP(' ')
	ENDIF
C RESET RUNMODE STRING NOW
	RUNMODE=RUM
	END SUBROUTINE CTRLINF
