	SUBROUTINE CHANN
**********************************************************************
*  Allocation of different channels inside the program:              *
**********************************************************************
	USE COM_CHANNELS
C  CONTROLS
	IUCTR=101 !   Control information                Permanent
	IULOG=102 !   Log     information                Permanent
	IUABR=103 !   Abort   information                Permanent
C  ELECTRONS FILES
	IUINP=01  !   Read all input files                                  
      IUOUT=02  !   Standard output to OUTFILE         Permanent          
      IUAIN=03  !   Additional output channel          Permanent          
      IUSCF=04  !   Charge density SCFFILE        Permanent/Temporary     
      IUTIN=05  !   Terminal Input                                        
      IUTOU=06  !   Terminal Output                                       
      IUMAD=07  !   Madelung's constants               Temporary          
      IUCON=08  !   Structure constants CONFILE    Permanent/Temporary    
      IUCEL=09  !   Cell description                   Temporary          
      IUBND=10  !   Energy bands BNDFILE           Permanent/Temporary    
      IUSRF=11  !   Cell constants SRFFILE         Permanent/Temporary    
      IUPOT=12  !   Full potential POTFILE         Permanent/Temporary    
      IUNMT=13  !   Potential parameters NMT           Temporary          
      IUWFK=14  !   Wave functions for one k-point     Temporary          
      IUPSI=15  !   Wave functions PSIFILE         Permanent/Temporary    
      IUPUL=16  !   Pulay forces                       Temporary          
      IUDOS=17  !   Density of states data             Temporary          
      IUPIN=18  !   Potential parameters INT           Temporary          
      IUPDS=19  !   Pseudodensity parameters           Temporary          
      IUPFC=20  !   Pulay force parameters             Temporary          
      IUTOS=21  !   Number of states matrix            Temporary          
      IUBMF=22  !   Broyden mixing in FTB              Permanent          
      IUBRO=23  !   Broyden mixing in LMT              Temporary          
      IUSSC=24  !   Screened structure constants                          
      IUPLZ=25  !   Polarizability PLZFILE             Permanent          
      IUPLS=26  !   Pseudopolarizability PLSFILE       Permanent          
      IUPLY=27  !   Polarizabilty                      Temporary          
      IUPSY=28  !   Pseudopolarizability               Temporary          
      IUSTN=29  !   Stoner matrix (not ready)          Permanent          
      IUDRO=30  !   Induced charge density             Temporary          
      IUDPS=31  !   Induced pseudodensity              Temporary          
      IUDRX=32  !   Induced charge density DROFILE     Permanent          
      IUDPX=33  !   Induced charge density             Temporary          
      IUDRY=34  !   Induced pseudodensity  DPSFILE     Permanent          
      IUDPY=35  !   Induced pseudodensity              Temporary          
      IUDSV=36  !   Induced potential DSVFILE      Permanent/Temporary    
      IUDPV=37  !   Induced pseudopot.DPVFILE      Permanent/Temporary    
C           38  !   Empty                                                 
      IUTTR=39  !   Tetrahedron weights                Temporary          
      IUTTW=40  !   Tetrahedron weights WGTFILE        Permanent          
      IUDMT=41  !   Change in NMT parameters           Temporary          
      IUDTS=42  !   Change in TOS matrix               Temporary          
      IUBMT=43  !   Change in BMT parameters           Temporary          
      IUBOS=44  !   Change in BOS matrix               Temporary          
      IUDYN=45  !   Dynamical matrix data              Temporary          
      IUDIN=46  !   Induced INT parameters             Temporary          
      IUPDD=47  !   Induced pseudodensity data         Temporary          
      IUDMD=48  !   Dynamical matrix data              Temporary          
      IUOPT=49  !   Optical properties                 Temporary
C           50  !                                                         
	IUCHI=51  !   Dynamical susceptibility           Temporary
	IUTDS=52  !   Eigenvectors of H+Sigma(iWn)       Temporary
	IUCEW=53  !   Eigenvectors of H+Sigma(iWn)       Temporary
	IUSGM=54  !   Self-energy/Hybridization          Temporary
	IUBIM=55  !   Broyden mixing for the impurity    Temporary
	IUBSG=56  !   Broyden mixing for the self-energy Temporary
	IUHAM=57  !   Hamiltonian and overlap matrices   Temporary
	IUGRF=58  !   Greens function on the real axis   Temporary
	IULRV=59  !   LMTO eigenvectors for Greens fun.  Temporary
	IUINV=60  !   Inverse overlap integrals          Temporary
	IUGZW=61  !   Gutzwiller interpolation data      Temporary
	IUGWA=62  !   On-site Green function             Temporary
	END
